<!--
Thank you for taking the time to open an issue for restify! If this is your
first time here, welcome to our community! We are a group of developers who
work on restify in our free-time. Some of us do it as a hobby, others are using
restify at work. When asking for help here, keep in mind most of us are
volunteers contributing our daily work back to the community at no cost (and
often for no reward). Please be respectful!

Below you will find two templates, one for filing a bug report, and the other
for requesting a feature. Remove the comments from around the template that is
applicable to your case and fill it out accordingly. This standardization helps
the maintainers gather the information they need up front to verify and respond
to problems accordingly, ensuring you get the fastest response possible!  -->

<!-- REQUIRED: Pre-Submission Checklist -->

- [ ] Used appropriate template for the issue type
- [ ] Searched both open and closed issues for duplicates of this issue
- [ ] Title adequately and _concisely_ reflects the feature or the bug

<!--

# Bug Report

## Restify Version

## Node.js Version

## Expected behaviour

> This section details what you expected restify to do based on the code that you wrote

## Actual behaviour

> This section details what restify actually did when you ran your code

## Repro case

> Please include a simple and concise example reproducing this bug. Please _do
> not_ just dump your application here. By either not providing a repro case or
> by providing an overly complicated repro case, you are offloading the work of
> isolating your bug to other developers, many of which are here voluntarily.
> Good repro cases are single file Node.js applications, where the only logic
> present is logic necessary to expose the undesired behaviour. You will often
> find that when creating your repro case, you will solve the problem yourself!

## Cause

> If you have been able to trace the bug back to it source(s) in the code base,
> please link to them here.

## Are you willing and able to fix this?

> "Yes" or, if "no", what can current contributors do to help you create a PR?
> If this issue is unique, as the checklist you completed above suggests, then
> you are one of the few people who have encountered this bug in the wild.
> While contributors will often help work on issues out of the kindness of
> their hearts, its important to remember that you are the largest stakeholder
> in seeing this bug resolved as you are the one experiencing it. Kindness
> and contributions are what make Free Software go round, help pay it forward!

-->
<!--

# Feature Request

## Use Case

> Why do you want this?

## Example API

> This should include code snippets and documentation for the proposed feature

## Are you willing and able to implement this?

> "Yes" or, if "no", what can current contributors do to help you create a PR?

-->
